function fredfil3(a0)
%function fredfil3(a0),
% all-pass filter design called by polyz3 
% Script file written by fred harris of SDSU. Copyright 2002

%aa1=[1   3*a0  3*a0*a0 a0*a0*a0];
%aa1=[1 a0]
aa1=conv([1  a0],[1 a0]);
%aa1=conv(aa1,aa1);
bb1=fliplr(aa1);


[h1,w]=freqz(bb1,aa1,200);
phi1=unwrap(angle(h1))*180/pi;
subplot(3,1,1);
plot(w/(2*pi),phi1);
grid on;
axis([0 .5 -360 0]);
ylabel('Phase Shift');

subplot(3,1,3); 
zd=zeros(1,20);zd(2:8)=hanning(7)';
dd=filter(bb1,aa1,zd);
zdi=0:.25:19;yi=interp1(0:19,dd,zdi,'cubic');
fyi=log10(abs(fft(zd,400)));fyi=1+(fyi-max(fyi))/2;
stem(0:19,dd);hold;plot(zdi,yi,'r');grid on;axis([0 20 -.2 1.2]);hold
ylabel('S(n) & S(t)')

subplot(3,1,2);
gd=(200/pi)*conv([-1 1],unwrap(angle(h1)));
id=find(gd<0);
gd(id)=gd(id-1);
plot(w/(2*pi),gd(1:200));
hold;
plot(w/(2*pi),fyi(1:200),'r');hold;
grid on;
axis([0 .5 0 2]);

ylabel('Delay & |S(w)|');

