function response=getResponse(N,R,wr,resolution);
% Script file written by Dragan Vultec and fred harris of SDSU. Copyright 2002

for i=1:N-1
   n=i;
   [gPZNum(i,:),gPZDen(i,:)]=getZfunction(N,R,n,wr);
   NN=[zeros(1,i) gPZNum(i,:)];
   H(i,:)=freqz(NN,gPZDen(i,:),0:pi/resolution:2*pi/N-pi/resolution);
end
N0=[zeros(1,N*R) 1];
H0=freqz(N0,1,0:pi/resolution:2*pi/N-pi/resolution);
if N>2
   response=20*log10(1/N*(abs(sum(H)+H0)));
else
   response=20*log10(1/N*(abs(H+H0)));
end


return

