
%function polyzz
% polyx forms a recursive polyphase filter and examines a number of its properties
% Script file written by fred harris of SDSU. Copyright 2002

global sli_a0  a0_min a0_label a0_cur pb_close

initval=0.333;
fig=figure;
clf
%the callback defines the coefficients' value property
%from the sliders' current value (value property) and
% set the text control that specifies the sliders' current value

fredfil3(initval);
cposit=[400 3 120 20];

pb_close=uicontrol(gcf,...
		'Style','push',...
		'String','Close Window',...
		'Position',cposit,...
		'CallBack','close(gcf)');

% defining slider

sli_a0 = uicontrol(fig,'style','slider',...
	'position',[80 3 120 20],...
   	'min',0,'max',+1,'value',initval,...
   	'CallBack',['dum=get(sli_a0,''val'');',...
			'set(a0_cur,''string'',num2str(dum)),',...
  		        'set(gca,''view'',[0 dum]),',...
			'fredfil3(dum);',...
			]);

a0_min=uicontrol(fig,'style','text','pos',[50 3 30 20],...
   'string',num2str(get(sli_a0,'min')));
a0_max=uicontrol(fig,'style','text','pos',[200 3 30 20],...
   'string',num2str(get(sli_a0,'max')),'horiz','right');
% define the slider labels
a0_label = uicontrol(fig,'style','text','pos',[245 3 65 20],...
   'string','coef a0');
%a1_label = uicontrol(fig,'style','text','pos',[400 3 65 20],...
%   'string','delay');
% deFine the text control for the current value,
% the values are initially set by these statements,
% but the sliders' callbacks set them after the user changes them

%a0_cur = uicontrol(fig,'style','text','pos',[300 3 65 20],...
%   'string',num2str(get(sli_a0,'value')));

a0_cur = uicontrol(fig,'style','text','pos',[315 3 40 20],...
   'string',num2str(get(sli_a0,'value')));


%a1_cur = uicontrol(fig,'style','text','pos',[470 3 60 20],...
%   'string',num2str(((1-get(sli_a0,'value'))/(1+get(sli_a0,'value')))^2));

