function [beta]=findBeta(Omegas,phases)
% Script file written by Dragan Vultec and fred harris of SDSU. Copyright 2002

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%% finds all betas 
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
beta(1)=phases(1)/Omegas(1);
if length(phases)==1 
   return 
end
beta(2)=1/(Omegas(2)^2-Omegas(1)^2)*(1-beta(1)*Omegas(2)/phases(2));
if length(phases)==2
   return 
end
for r=3:length(phases)
   beta(r)=betaRecur(1,r,beta,phases,Omegas)/(Omegas(r)^2-Omegas(r-1)^2);
end

   
   