function [PZNum,PZDen]=getZfunction(N,R,n,wr)
% Script file written by Dragan Vultec and fred harris of SDSU. Copyright 2002

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%% finds Z polynomial
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for r=1:R
   Omegas(r)=tan(N*wr(r)/2);
	phases(r)=tan((-N*R*wr(r)+n*wr(r))/2);
end
%Omegas=[tan(pi/6) tan(pi/5) tan(pi/4)];
%phases=[tan(pi/6) tan(pi/4) tan(pi/3)];
beta=findBeta(Omegas,phases);
polynomial=findPolynomial(beta,Omegas);
polynomial=polynomial(length(beta)+1,:);
polynomial_2=zeros(1,length(polynomial));

for i=length(polynomial):-1:1
   polynomial_2(i)=(-1)^(i-length(polynomial))*polynomial(i);
end
%freqs(polynomial,polynomial_2);
[PZNumZ,PZDenZ]=bilinear(polynomial,polynomial_2,1/2);
PZNum=[];
PZDen=[];
%%%%%%%%%%%     *** convert into Z^-N structure  ***    %%%%%%%%%%%
ZN=[1 zeros(1,N-1)];

for i=1:length(PZNumZ)-1
   PZNum=[PZNum PZNumZ(i)*ZN];
   PZDen=[PZDen PZDenZ(i)*ZN];
end
   PZNum=[PZNum PZNumZ(i+1)];
   PZDen=[PZDen PZDenZ(i+1)];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
   